import { jsx as _jsx } from "react/jsx-runtime";
import { isNumber, getControl } from 'handie-react';
import { StringFieldStructuralWidget } from 'handie-react/dist/widgets/class';
export default class PasswordEditStringFieldWidget extends StringFieldStructuralWidget {
    render() {
        const props = {
            value: this.props.value,
            placeholder: this.getPlaceholder(),
            disabled: this.state.disabled,
        };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.props.field;
            if (isNumber(min)) {
                props.minLength = min;
            }
            if (isNumber(max)) {
                props.maxLength = max;
            }
        }
        const Password = getControl('Password');
        return Password ? (_jsx(Password, Object.assign({}, props, { onInput: (value) => this.onChange(value) }), void 0)) : null;
    }
}
