import { jsx as _jsx } from "react/jsx-runtime";
import { isNumber, getControl, } from 'handie-react';
import { StringFieldStructuralWidget } from 'handie-react/dist/widgets/class';
export default class UrlEditStringFieldWidget extends StringFieldStructuralWidget {
    render() {
        const props = {
            value: this.props.value,
            placeholder: this.getPlaceholder(),
            disabled: this.state.disabled,
            scheme: this.config.scheme || 'http',
            noAuthority: this.config.noAuthority,
        };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.props.field;
            if (isNumber(min)) {
                props.minLength = min;
            }
            if (isNumber(max)) {
                props.maxLength = max;
            }
        }
        const UrlInput = getControl('UrlInput');
        return UrlInput ? (_jsx(UrlInput, Object.assign({}, props, { onChange: (value) => this.onChange(value) }), void 0)) : null;
    }
}
